/*==========================================================================
//  x_hook.h -- by Patrick Martin               Last updated:  10-28-1998
//--------------------------------------------------------------------------
//  This is the header file for x_hook.c.
//========================================================================*/

/***************/
/*  CONSTANTS  */
/***************/

/* Cable source styles. */
#define CABLE_NORMAL    0
#define CABLE_REVERSE   1

/* Target types. */
#define TARGET_NONE     0
#define TARGET_MORTAL   1
#define TARGET_WORLD    2


/****************/
/*  PROTOTYPES  */
/****************/

/*
// x_hook.c
*/
void Coven_KillGrapple (edict_t *self);
qboolean Coven_CutCable (edict_t *self);
qboolean Coven_GrappleAttack (edict_t *self);
qboolean Coven_GrapplePull (edict_t *self);
int Coven_TargetType (edict_t *self);
qboolean Coven_GrappleDone (edict_t *self);
void Coven_CheckGrapple (edict_t *self);
void Coven_GrappleTouch
 (edict_t *self, edict_t *other, cplane_t *plane, csurface_t *surf);
void Coven_GrappleThink (edict_t *self);
void Coven_FireGrapple
 (edict_t *self, vec3_t start, vec3_t dir, vec3_t offset, int damage,
  int hold_damage, int speed, float hold_range, float cable_range);


/*===========================/  END OF FILE  /===========================*/
